=== debian/changelog ===
macaulay2 (1.19.1+ds-8) unstable; urgency=medium

  * debian/tests/control
    - Add 4ti2, gfan, and normaliz to Depends for core-tests
      (Closes: #1010172).

 -- Doug Torrance <dtorrance@debian.org>  Mon, 25 Apr 2022 14:14:15 -0400

macaulay2 (1.19.1+ds-7) unstable; urgency=medium

  * debian/gbp.conf
    - Switch to "debian/latest" for Debian branch; recommended by DEP-14.
  * debian/macaulay2-common.links
    - New file; use dh_link to create symlinks to GPL text for docs.
  * debian/macaulay2-common.linktree
    - Stop use dh_linktree for creating symlinks to GPL text for docs;
      was creating unnecessary versioned dependency on base-files
      (Closes: #1009838).
  * debian/patches/skip-failing-package-tests.patch
    - Skip new failing package tests:
      + check(4, "ThreadedGB"); failing on ppc64el.
      + check({25, 31}, "AssociativeAlgebras"); failing  on ppc64el
         (Closes: #1010096).
  * debian/scripts/m2-get-orig-source.sh
    - Run missingPackages() when --merge option is given to see if any new
      packages should be added to d/copyright.
  * debian/tests/control
    - Split each "M2 --check n" into its own separate test.
    - Use "macaulay2" instead of "@" in Depends since we don't need
      elpa-macaulay2.
    - Add test names.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 24 Apr 2022 21:05:14 -0400

macaulay2 (1.19.1+ds-6) unstable; urgency=medium

  * debian/control
    - Exclude python3-dev from Build-Depends with nopython build profile.
  * debian/macaulay2-common.install
    - Install make-M2-symbols.m2; generates files for syntax highlighting
      in Emacs, Pygments, etc.
  * debian/patches/skip-failing-package-tests.patch
    - Properly skip tests marked "no-check-architecture".
  * debian/patches/tbb-2021.patch
    - New patch; add support for TBB 2021.
  * debian/patches/use-dh-elpa.patch
    - Fix path to M2-emacs-help.txt in documentation.
  * debian/rules
    - Don't build with Python support with "nopython" build profile.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 11 Feb 2022 11:25:09 -0500

macaulay2 (1.19.1+ds-5) unstable; urgency=medium

  * debian/control
    - Remove w3c-markup-validator from Build-Depends-Indep; it is only used
      for validating the html documentation, which we are currently
      skipping.
    - Add phcpack to Suggests.
  * debian/README.Debian
    - Add blurb about phcpack to "Suggested packages" section.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 27 Jan 2022 11:42:39 -0500

macaulay2 (1.19.1+ds-4) unstable; urgency=medium

  * debian/patches/givaro-bool-constant.patch
    - New patch; fix "'givaro_bool_constant' does not name a type" error
      when building with givaro 4.2.0 and fflas-ffpack 2.5.0, which are
      now in Debian.
  * debian/rules
    - Make dump directories inside the dump file targets instead of their
      own; fixes strange "unlink" message that was appearing in the build
      logs.
  * debian/scripts/m2-get-orig-source.sh
    - Make the repack suffix a variable.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 19 Dec 2021 07:29:32 -0500

macaulay2 (1.19.1+ds-3) unstable; urgency=medium

  * debian/control
    - Add versioned dependency on libsingular4-dev; configure script will
      fail if < 4.2.0 is found.  For this reason, we can't depend on
      the virtual package libsingular-dev any more.
    - Add gdbmtool and faketime to Build-Depends-Indep; needed for
      generating reproducible dumps of the documentation database files.
    - Add gdbmtool to Depends for macaulay2; needed for new postinst
      script.
  * debian/macaulay2.install
    - Stop installing files in /usr/lib; no longer necessary now that we
      will generate package documentation databases during postinst.
  * debian/macaulay2.postinst
    - New file; load package documentation databases from dump files after
      installation.
  * debian/macaulay2.prerem
    - New file; remove directories containing package documentation
      databases that were created during postinst.
  * debian/patches/allow-older-factory.patch
    - Remove patch; no longer necessary as singular 4.2.1 is now in Debian.
  * debian/patches/skip-failing-core-tests.patch
    - Fix ComputationsBook::varieties test instead of skipping it.
  * debian/rules
    - Append -indep to execute_before_dh_auto_build target; we only need
      the dummy KaTeX files and cached examples when building the
      documentation.
    - New override_dh_auto_build target; only build documentation when
      building macaulay2-common.
    - Append -indep to execute_after_dh_auto_install target; the cached
      example directories will only exist and need to be removed when
      building the documentation.
    - Also in execute_after_dh_auto_install, create dumps of package
      documentation to ship with macaulay2-common and then load during
      postinst and then remove the database files.
    - Remove execute_after_dh_install-arch target; empty directory is now
      removed with the package documentation database after they're dumped.
    - Exclude database dump files from dh_compress.
    - Add override_dh_installdeb target to substitute variables in new
      maintainer scripts.
  * debian/salsa-ci.yml
    - Stop allowing reprotest to fail; the parts of the package that are
      built on Salsa are now reproducible.
    - Allow autopkgtest to fail; the new test requires the documentation to
      be built, which doesn't happen on Salsa.
  * debian/scripts/Debian.m2
    - Stop caching almost all examples; since we won't be building them on
      non-amd64 architectures, we should see far fewer failures.
    - Add new "skipTestArch" function to skip tests only on a particular
      architecture.
  * debian/scripts/m2-get-orig-source.sh
    - Update string to grep for when "quilt push" fails.
  * debian/tests/check-doc-db.m2
    - New CI test for autopkgtest; test that the documentation database can
      be loaded.
  * debian/upstream/metadata

