=== debian/tests/control ===
Test-Command: M2 --silent --check 1 -q --stop -E "exit 0"
Depends: macaulay2
Restrictions: allow-stderr
Features: test-name=basic-tests

Test-Command: M2 --check 2
Depends: 4ti2, gfan, macaulay2, normaliz
Restrictions: allow-stderr
Features: test-name=core-tests

Test-Command: M2 --check 3
Depends: 4ti2, cohomcalg, coinor-csdp, gfan, macaulay2, nauty, normaliz, topcom
Restrictions: allow-stderr
Features: test-name=package-tests

Test-Command: M2 --script debian/tests/check-doc-db.m2
Depends: macaulay2
Features: test-name=database-smoke-test
